<?php

require_once('myChatServer.php');

$port = CHAT_PORT;
$adresse = CHAT_DOMAIN;

set_time_limit(0);

header('Content-type: text/html; charset=utf-8');

?>
<html>
<body>
<?php

if(!isset($_GET['pseudo']))
{
  echo myChatServer::format_message('<p>indiquer votre pseudo : url?pseudo=votrePseudo</p>');
  exit();
}

echo myChatServer::format_message('<p>connexion au chat...</p>'.str_repeat(" ", 256));
ob_flush();
flush();

//  Connexion au serveur de chat
$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
if(!@socket_connect($socket, $adresse, $port))
{
  echo myChatServer::format_message('<p>Le serveur n\'est pas lancé...</p>');
  echo myChatServer::format_message('<p>démarrage auto...</p>');
  echo myChatServer::format_message('<p>le serveur se stopera au bout de 60 secondes d\'inactivité</p>');
  ob_flush();
  flush();

  $ch = curl_init();

  //set the url, timeout
  $url = 'http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['SCRIPT_NAME']).'/server_start.php';
  curl_setopt($ch,CURLOPT_URL,$url);
  curl_setopt($ch,CURLOPT_TIMEOUT, 1);

  //execute post
  $result = curl_exec($ch);

  //close connection
  curl_close($ch);
}

//  Connexion au serveur de chat
$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
if(!@socket_connect($socket, $adresse, $port))
{
  echo myChatServer::format_message('<p>Le serveur n\'est pas lancé...</p>');
  exit();
}
//

//  On envoie la demande de connexion
$data = array(
  'action'=>'userConnect',
  'username'=>$_GET['pseudo'],
  'userip'=>$_SERVER['REMOTE_ADDR'],
  'userid'=>1,
  'room'=>'room1',
  'lang'=>'fr'
);
$data = serialize($data)."\n";


if(!@socket_write($socket, $data, strlen($data)))
{
  echo myChatServer::format_message('<p>impossible de se connecter au chat</p>');
  exit();
}
//

//  On boucle et on attends la reception de données
while(true)
{
  $data = "";

  //  read data from socket
  while($buffer = @socket_read($socket, 512))
  {
    $data .= $buffer;

    $endString = substr($buffer, - strlen("\n"));
    if($endString == "\n")
    {
      break;
    }
  }

  if($buffer == false)
  {
    echo myChatServer::format_message('<p>Le serveur a été éteint</p><div class="chatlistuser" style="display:none;"></div>');
    exit();
  }
  else
  {
    echo stripslashes($data);
  }

  ob_flush();
  flush();
}
//

//  On ferme la connexion
socket_close($socket);
//
?>
</body>
</html>
