function newXHR()
{
  var xhr_object = null;
  if(window.XMLHttpRequest) // Firefox et autres
  {
    xhr_object = new XMLHttpRequest();
  }
  else if(window.ActiveXObject) // Internet Explorer
  {
    try
    {
      xhr_object = new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch (e)
    {
      xhr_object = new ActiveXObject("Microsoft.XMLHTTP");
    }
  }
  else  // XMLHttpRequest non supporte par le navigateur
  {
    xhr_object = false;
  }

  return xhr_object;
}

function streamingHTTP(filename, toDiv)
{
  var myXHR = newXHR();
  var response_length = 0;
  var marker = false;

  if(myXHR == false || filename.length == 0)
  {
    return false;
  }

  var update = function()
  {
    if(myXHR.readyState >= 3 && myXHR.responseText.length > response_length)
    {
      response_length = myXHR.responseText.length;
      var div = document.getElementById(toDiv);

      if(marker && marker != false)
      {
        $(myXHR.responseText).next('#'+marker).nextAll('.message').each(function()
        {
          console.log(this);
          div.innerHTML = div.innerHTML+$(this).html();
        });
      }
      else
      {
        div.innerHTML = myXHR.responseText;
      }

      div.scrollTop = div.scrollHeight;

      var tmp = $(myXHR.responseText).next('.message:last');
      marker = tmp.attr('id');
      console.log(marker);
    }

    setTimeout(update,100); //  Se relance toute les 100 ms
  };

  update();

  myXHR.open('GET', filename, true);
  myXHR.send();
}

function updateChatRoomUser()
{
  //  Internet explorer - streaming via iframe
  var userList = $('#frameChat').contents().find('div.chatlistuser:last');

  //  Les autres
  if(userList.length == 0)
  {
    userList = $('div.chatlistuser:last');
  }

  if(userList.length > 0)
  {
    $('#userList').html(userList.html());
    $('div.chatlistuser').remove();
  }

  setTimeout(updateChatRoomUser, 100);
}

function updateFrameScrollTop()
{
  var elt = document.getElementById("frameChat");

  if(elt.contentWindow.document.body != null)
  {
    elt.contentWindow.document.body.scrollTop = elt.contentWindow.document.body.scrollHeight;
  }
  setTimeout(updateFrameScrollTop,100);
}


$(document).ready(function()
{
  updateChatRoomUser();

  $('form').submit(function()
  {
    var formSend = this;
    $.post(formSend.action, $(formSend).serialize(), function(data)
    {
      $('textarea').val('');
    });

    return false;
  });

  $('textarea').keypress(function(e)
  {
    c = e.which ? e.which : e.keyCode;

    if(c == 13)
    {
      $('form').submit();
      return false;
    }
  });
});
